xquery version "1.0";
declare namespace rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#";
declare namespace owl="http://www.w3.org/2002/07/owl#";
declare namespace petra="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#";
declare namespace request="http://exist-db.org/xquery/request";

let $zona   := request:get-parameter("zona", "")
let $sector := request:get-parameter("sector", "")
let $paret  := request:get-parameter("paret", "")
let $nomvia := request:get-parameter("via", "")

let $zonaabout   := data(collection('petraCAT')//owl:NamedIndividual[./petra:nom = $zona and ./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Zona"]//@rdf:about)
let $sectorabout := data(collection('petraCAT')//owl:NamedIndividual[(./petra:nom = $sector and ./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Sector") and (data(./petra:isSectorOf/@rdf:resource)=$zonaabout)]//@rdf:about)
let $par         := collection('petraCAT')//owl:NamedIndividual[(./petra:nom = $paret and ./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Paret") and (data(./petra:isParetOf/@rdf:resource)=$sectorabout)]
let $paretabout  := data(collection('petraCAT')//owl:NamedIndividual[(./petra:nom = $paret and ./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Paret") and (data(./petra:isParetOf/@rdf:resource)=$sectorabout)]//@rdf:about)

let $via := collection('petraCAT')//owl:NamedIndividual[(./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Via") and (data(./petra:isViaOf/@rdf:resource)=$paretabout) and (data(./petra:nom)=$nomvia)]
let $viaabout      := data($via//@rdf:about)

let $tipusescalada := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#TipusEscalada" and ./@rdf:about=$via/petra:isClimbedIn/@rdf:resource]
let $orientacio    := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Orientacio" and ./@rdf:about=$via/petra:hasOrientacio/@rdf:resource]
let $roca          := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Roca" and ./@rdf:about=$par/petra:isMadeOfRoca/@rdf:resource]
let $esquema       := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#EsquemaVia" and ./@rdf:about=$via/petra:hasUri/@rdf:resource]
let $links         := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Link" and ./@rdf:about=$via/petra:hasUri/@rdf:resource]
let $encastadors   := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Encastador" and ./@rdf:about=$via/petra:weUseEncastador/@rdf:resource]
let $ancoratges    := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Ancoratge" and ./@rdf:about=$via/petra:hasAncoratge/@rdf:resource]
let $parquing      := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Parquing" and ./@rdf:about=$via/petra:isNearOf/@rdf:resource]
let $allotjaments  := collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Allotjament" and ./@rdf:about=$via/petra:isNearOf/@rdf:resource]

return
<via>
     <zona>{$zona}</zona>
     <sector>{$sector}</sector>
     <paret>{$paret}</paret>
     <nom>{data($nomvia)}</nom>
     <gps>
          <latitud>{data($via/petra:latitud)}</latitud>
          <longitud>{data($via/petra:longitud)}</longitud>
     </gps>
     <dificultatM>{data($via/petra:dificultadMaxima)}</dificultatM>
     <dificultatO>{data($via/petra:dificultadMaximaObligatoria)}</dificultatO>
     <metres>{data($via/petra:metres)}</metres>
     <llargs>{
          if(data($via/rdf:type/@rdf:resource)="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#ViaDiversosLlargs") then data($via/petra:llargs)
          else 1
     }</llargs>
     <escalada>{data($tipusescalada/petra:nom)}</escalada>
     <tipus>{
          if($via/rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#ViaEquipada") then "Equipada"
          else if ($via/rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#ViaDesequipada") then "Desequipada"
          else "Semiequipada"
     }</tipus>
     <orientacio>{data($orientacio/petra:nom)}</orientacio>
     <roca>{data($roca/petra:tipusRoca)}</roca>
     <esquema>{data($esquema/petra:uri)}</esquema>
     <aproximacio>{data($via/petra:acces)}</aproximacio>
     <descens>{data($via/petra:descens)}</descens>
     <enllacos>{
          for $link in $links return <enllac>{data($link/petra:uri)}</enllac>
     }</enllacos>

     {if(count($encastadors)>0) then
     <material>{
          for $mat in $encastadors return <mat>{data($mat/petra:nom)}</mat>
     }</material>
     else ""}

     {if(count($ancoratges))then
     <equipament>{
          for $anc in $ancoratges return <ancoratge>{data($anc/petra:nom)}</ancoratge>
     }</equipament>
     else ""}

     <parquing>
          <gps>
               <latitud>{data($parquing/petra:latitud)}</latitud>
               <longitud>{data($parquing/petra:longitud)}</longitud>
          </gps>
          <acces>{data($parquing/petra:acces)}</acces>
          <descripcio>{data($parquing/petra:descripcio)}</descripcio>
     </parquing>

     {if(count($allotjaments)>0)then
     <allotjaments>{
          for $allot in $allotjaments
          let $tipusAllotjament := if(ends-with(data($allot/rdf:type/@rdf:resource),"#Refugi"))then "refugi" else "alberg"
          return
          <allotjament tipus="{$tipusAllotjament}">
               <nom>{data($allot/petra:nom)}</nom>
               <gps>
                    <latitud>{data($allot/petra:latitud)}</latitud>
                    <longitud>{data($allot/petra:longitud)}</longitud>
               </gps>
               <acces>{data($allot/petra:acces)}</acces>

               {if(string-length(data($allot/petra:adreca))>0)then
               <adreca>{data($allot/petra:adreca)}</adreca>
               else ""}

               <poblacio>{data($allot/petra:poblacio)}</poblacio>
               {if($tipusAllotjament="refugi")then
               <serveis>
                    <guardat>{data($allot/petra:guardat)}</guardat>
                    <places>{data($allot/petra:places)}</places>
                    <placesng>{data($allot/petra:placesng)}</placesng>
                    <llum>{data($allot/petra:llum)}</llum>
                    <aigua>{data($allot/petra:aigua)}</aigua>
                    <calefaccio>{data($allot/petra:calefaccio)}</calefaccio>
                    <lliteres>{data($allot/petra:lliteres)}</lliteres>
                    <matalassos>{data($allot/petra:matalassos)}</matalassos>
                    <wc>{data($allot/petra:wc)}</wc>
                    <cuina>{data($allot/petra:cuina)}</cuina>
               </serveis>
               else ""}

               {let $lengthT := string-length(data($allot/petra:telefon))
               let $lengthM  := string-length(data($allot/petra:mail))
               return
               if($lengthT>0 or $lengthM>0)then
               <contacte>
                    {if($lengthT>0)then <telefon>{data($allot/petra:telefon)}</telefon> else ""}
                    {if($lengthM>0)then <mail>{data($allot/petra:mail)}</mail> else ""}
               </contacte>
               else ""}
          </allotjament>
     }</allotjaments>
     else ""}
</via>
