xquery version "1.0";
declare namespace rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#";
declare namespace owl="http://www.w3.org/2002/07/owl#";
declare namespace petra="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#";
declare namespace request="http://exist-db.org/xquery/request";

let $orientacio := concat("#",request:get-parameter("orientacio", ""))
let $escalada   := concat("#",request:get-parameter("escalada", ""))
let $tipus      := concat("#",request:get-parameter("tipus", ""))
let $llargs     := concat("#",request:get-parameter("llargs", ""))
let $roca       := concat("#",request:get-parameter("roca", ""))
let $dmax       := request:get-parameter("dmaxima","")

return
<resum>{
     for $zona in collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Zona"]
     return
          <zona nom="{data($zona/petra:nom)}">{
               for $sector in collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Sector"]
               where data($zona/@rdf:about) = data($sector/petra:isSectorOf/@rdf:resource)
               return
                    <sector nom="{data($sector/petra:nom)}">{
                         for $paret in collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Paret"]
                         where data($sector/@rdf:about) = data($paret/petra:isParetOf/@rdf:resource)
                         return
                              <paret nom="{$paret/petra:nom}">{
                                   for $via in collection('petraCAT')//owl:NamedIndividual[(./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Via") and (data($paret/@rdf:about) = data(./petra:isViaOf/@rdf:resource))]
                                   where (($orientacio="#" or ends-with(data($via/petra:hasOrientacio/@rdf:resource), $orientacio)) and ($escalada="#" or ends-with(data($via/petra:isClimbedIn/@rdf:resource), $escalada)) and($tipus="#" or ends-with(data($via/rdf:type/@rdf:resource), $tipus)) and($llargs="#" or ends-with(data($via/rdf:type/@rdf:resource),$llargs)) and($roca="#"or ends-with(data($paret/petra:isMadeOfRoca/@rdf:resource), $roca)) and ($dmax="" or contains($dmax,concat(":",data($via/petra:dificultadMaxima),":"))))
                                   return
                                        <via>
                                           <nom>{data($via/petra:nom)}</nom>
                                           <dmaxima>{data($via/petra:dificultadMaxima)}</dmaxima>
                                           <dobligada>{data($via/petra:dificultadMaximaObligatoria)}</dobligada>
                                           <metres>{data($via/petra:metres)}</metres>
                                        </via>
                              }</paret>
                    }</sector>
          }</zona>
}</resum>
