xquery version "1.0";
declare namespace rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#";
declare namespace owl="http://www.w3.org/2002/07/owl#";
declare namespace petra="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#";
declare namespace request="http://exist-db.org/xquery/request";

let $orientacio := concat("#",request:get-parameter("orientacio", ""))
let $escalada   := concat("#",request:get-parameter("escalada", ""))
let $tipus      := concat("#",request:get-parameter("tipus", ""))
let $llargs     := concat("#",request:get-parameter("llargs", ""))
let $roca       := concat("#",request:get-parameter("roca", ""))
let $dmax       := request:get-parameter("dmaxima", "")
let $zonasect    := substring(request:get-parameter("zonasector", ""), 2)

return
<resum>{
     for $zs in tokenize($zonasect, "#")
     let $zona := tokenize($zs, ":")[1]
     let $zonaabout := data(collection('petraCAT')//owl:NamedIndividual[./petra:nom = $zona and ./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Zona"]/@rdf:about)
     let $zlength:= (string-length($zona) + 2)
     let $s := substring($zs, $zlength)
     return
          <zona nom="{$zona}">{
               for $sector in tokenize($s, ":")
               let $sectorabout := data(collection('petraCAT')//owl:NamedIndividual[./petra:nom = $sector and ./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Sector"]//@rdf:about)
               return <sector nom="{$sector}">{
                    for $paret in collection('petraCAT')//owl:NamedIndividual[./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Paret"]
                    where $sectorabout = data($paret/petra:isParetOf/@rdf:resource)
                    return <paret nom="{$paret/petra:nom}">{
                         for $via in collection('petraCAT')//owl:NamedIndividual[(./rdf:type/@rdf:resource="http://www.semanticweb.org/ontologies/2011/4/PetraCATontologi.owl#Via") and (data($paret/@rdf:about) = data(./petra:isViaOf/@rdf:resource))]
                         where (($orientacio="#" or ends-with(data($via/petra:hasOrientacio/@rdf:resource), $orientacio)) and ($escalada="#" or ends-with(data($via/petra:isClimbedIn/@rdf:resource), $escalada)) and($tipus="#" or ends-with(data($via/rdf:type/@rdf:resource), $tipus)) and($llargs="#" or ends-with(data($via/rdf:type/@rdf:resource),$llargs)) and($roca="#"or ends-with(data($paret/petra:isMadeOfRoca/@rdf:resource), $roca)) and ($dmax="" or contains($dmax,concat(":",data($via/petra:dificultadMaxima),":"))))
                         return
                         <via>
                            <nom>{data($via/petra:nom)}</nom>
                            <dmaxima>{data($via/petra:dificultadMaxima)}</dmaxima>
                            <dobligada>{data($via/petra:dificultadMaximaObligatoria)}</dobligada>
                            <metres>{data($via/petra:metres)}</metres>
                         </via>
                    }</paret>
               }</sector>
          }</zona>
}</resum>
